# OpenGnsys Administration

Welcome to the administration section of OpenGnsys. This area provides detailed information about all the administrative components of the platform.

## Main Components

OpenGnsys consists of several administrative modules that work together to provide a complete solution for computer management and cloning:

- **[Web Console](oggui.md)**: Main interface for managing computers and tasks.
- **[DHCP](ogdhcp.md)**: Configuration and management of the DHCP service for client booting.
- **[Boot System](ogboot.md)**: Mechanisms and configurations for client booting.
- **[ogLive](oglive.md)**: Minimal operating system for performing cloning operations.
- **[Cloning Engine](ogcloneengine.md)**: Core of computer cloning operations.
- **[Repository Management](ogrepository.md)**: Management of images and repositories.
- **[ogAgent](ogagent.md)**: Agent for communication between clients and server.
- **[Logs and Monitoring](oglog.md)**: Tools for tracking and analyzing operations.

## Introduction to Administration

OpenGnsys administration allows centralized management of a set of computers, creating and deploying disk images, performing maintenance operations, and monitoring the status of the equipment.

This section offers detailed guides on each administrative component, with step-by-step instructions, configuration examples, and solutions to common problems.
