# Administration Interface

The Web console represents the greatest advancement of OpenGnsys in this new version, with the main features of:

- Developed with a modern and up-to-date language, Angular 18
- Responsive Web, working on both PC and mobile environments
- Multilingual, with English translation

![ogintro-webconsole.png](../assets/images/screenshots/ogintro-webconsole.png)

## Configuration

The new OpenGnsys administration interface has the following features for its Configuration

![oggui-config_menu.png](../assets/images/screenshots/oggui-config_menu.png){ align=center width=20% }

### Users

Allows creating, editing and deleting Users

![oggui-config_usuarios.png](../assets/images/screenshots/oggui-config_usuarios.png){ align=center }

#### Add User

![oggui-administracion-usuarios-anadir_usuario.png](../assets/images/screenshots/oggui-administracion-usuarios-anadir_usuario.png){ align=right width=40% } You will need to define the *username*, *password*, *role*, *organizational unit*, and *view*.

- **Username**: this will be used for login

- **Password**: the password is defined here by an administrator. The user will not be able to change the password unless they have access to the user administration panel.

- **Role**: allows assigning one or more roles to the user. Roles provide greater granularity when managing the permissions each user will have to administer the platform.

- **Organizational Unit**: allows defining which group of classrooms or machines the user will be able to administer. This field allows choosing one or more groups that the user can interact with. 

<div style="clear: both;"></div>

#### Edit User

This window allows editing all the fields that were defined during its creation.

#### Delete User

Allows deleting a user.

### Roles

Roles allow managing the access permissions that users have to administer the platform. Currently there are 4 administrative levels according to the roles:

- Super Admin: allows total control of the platform, without restrictions.
- Organizational Unit Admin: allows the user to perform all existing activities on the organizational unit.
- Organizational Unit Operator: 
- User

### Environment Variables

In this menu, the IPs and ports of the APIs for the different components are mainly defined

- OG_CORE_IP 
- OG_DHCP_API_URL 
- OG_BOOT_API_URL
- OG_LOG_IP
- REMOTEPC_AUTH_LOGIN
- REMOTEPC_AUTH_USERNAME
- REMOTEPC_AUTH_PASSWORD
- REMOTEPC_URL

## Navigating the Menus

In the left panel, we have the menus that give us access to the OpenGnsys features that we currently have active and running.
!!! note "Note" 
    It is possible that OpenGnsys does not include some modules, because they are served by external infrastructures, the most classic example is DHCP. In this case, when accessing that menu you will see a warning that this module is not enabled.

## Manage Groups

![oggui-grupos_crear.png](../assets/images/screenshots/oggui-grupos_crear.png){align=right width=50%}The main characteristics of groups are:

- Inheritance
    - Network and DHCP service
    - Boot Server
        - ogLive version
        - PXE template
    - NTP Server
    - Image Repository
        - Configuration of P2P values (mode, time)
        - Configuration of Multicast values (speed, port, mode)
    - Menu
    - Hardware Profile

Element groups are a hierarchical system that allows grouping of elements. The most common are Campus, Centers, Classrooms and Clients.

```mermaid
flowchart TB
    subgraph c1 [" Campus"]
        subgraph c2 [" Centro"]
            subgraph c3 [" Aula"]
                c4[" Cliente"]
            end
        end
    end

    classDef campusStyle fill:#f9d5e5,stroke:#333,stroke-width:3px
    classDef centroStyle fill:#eeeeee,stroke:#333,stroke-width:2px
    classDef aulaStyle fill:#b5ead7,stroke:#333,stroke-width:1px
    classDef clienteStyle fill:#c7ceea,stroke:#333,stroke-width:1px

    class c1 campusStyle
    class c2 centroStyle
    class c3 aulaStyle
    class c4 clienteStyle
```

<div style="clear: both;"></div>
