# ogDHCP: API for Kea DHCP Management

The `ogdhcp` component is a specialized API for efficiently managing the configuration of Kea DHCP, an open-source DHCP server developed by ISC (Internet Systems Consortium) that provides full support for both DHCPv4 and DHCPv6.

## Key Features

The `ogdhcp` API offers an intuitive interface that allows users and applications like OpenGNSys to interact remotely with Kea DHCP, eliminating the need to manually edit configuration files. This automated solution significantly streamlines network infrastructure management.

## Functionalities

The API provides a comprehensive set of operations that allow:

- Query the current Kea DHCP configuration in real time
- Perform end-to-end management of the Kea DHCP configuration:
  - Add, remove, or modify subnets
  - Manage IP address reservations
  - Configure DHCP-specific options
  - Customize server parameters

This tool is especially valuable for system administrators who need centralized and efficient DHCP configuration management in complex network environments.
