# OpenGnsys - Changelog v3.0.0 (May 19, 2025)

## Version Summary

This major release introduces significant improvements across all OpenGnsys components, including a new boot system, an updated cloning engine, Git integration, a revamped administration interface, and a new universal installer.

---

## Core Components

### OpenGnsys DHCP - ogDHCP v0.7.0

- Installation and configuration of DHCP via API.
- Management and assignment of networks to console objects.

### OpenGnsys Boot - ogBoot v0.7.1

#### Boot System
- Optimized services associated with PXE.
- Implemented a new, lighter and faster ogLive with updated drivers.
- Added an ogLive generation tool with support for Engine, Browser, and Agent dependencies.

### ogLive v3.3.0

#### Interface and Browser
- Incorporated the new OpenGnsys Browser with kiosk mode.
- Added full support for HTML5/CSS/JavaScript (ogBrowser).

#### Cloning Engine - ogCloningEngine v0.10.0
- Restructured the OpenGnsys Cloning Engine and partially migrated it to Python.
- Ensured exclusive use of open source components.

#### OpenGnsys Agent - ogAgent v5.3.0
- Implemented ogAgent for Windows, Linux, Mac, and ogLive developed in Python.

#### General Features
- Implemented calendar management for remote equipment usage.

---

## OpenGnsys Repository - ogRepository v0.8.1

#### Repository Improvements
- Expanded the functionality of the OpenGnsys Repository.
- Integrated with other system modules via REST API.

#### Transfers
- Optimized transfer methods: Unicast, Multicast, and P2P.
- Updated image transfer protocols.

#### API and Security
- Expanded features through REST API.
- TLS encryption for all APIs.

#### Git Management
- Added features for images synchronized with Git.
- Integrated Forgejo for advanced repository management via web interface.
- Added functions to create and select Git repositories.

#### Git Integration - ogGit v0.51
- Improved functions in Git.lib for cloning and restoration.
- Implemented a Python function library.
- Added automatic creation of Git repositories during installation.
- Incorporated synchronization between Git repositories and partitions.
---

## Administration Web - ogGui v0.13.0

#### Interface
- Completely redesigned web interface with responsive design.
- Maintained all previous functionalities.
- Improved visual experience and usability.

#### Modularity
- Implemented modular system management.
- Incorporated an advanced roles and permissions system.
- Added tag-based search.

#### Centralized Management - ogCore v0.13.0
- Unified administration of all components from the web.
- Eliminated the need for command-line tasks in routine operations.

#### Actions
- Implemented a new action management system by agent type.
- Added grouping into composite actions.
- Incorporated a complete action history.
- Implemented pending "required" actions.
- Added a wizard for predefined actions and advanced mode.

#### Clients
- Developed a new hierarchical structure for groups.
- Simplified group membership management.
- Added support for heterogeneous groups.
- Implemented configuration inheritance for deployment.
- Incorporated grid view visualization.
- Added the concept of a dynamic "view" based on criteria.

#### Repositories and Images
- Reorganized into group structures.
- Implemented distinction between image types.
- Improved information display for clients.
- Added support for multiple simultaneous repositories.
- Incorporated granular permissions and recycle bin.
- Implemented advanced searches and migration between repositories.

#### Profiles
- Added searches by advanced criteria.
- Implemented referential naming for profiles.
- Incorporated relationships between profiles for comparison.

#### Monitoring
- Developed a notification system.
- Added configurable statistics.
- Implemented contextual help.
- Unified communication via OpenGnsys Core.

---

## OpenGnsys Log Service

#### Logging System
- Implemented REST API for full integration.
- Centralized log storage and management.
- Incorporated collection agents.
- Added database processing (OpenSearch).

#### Visualization
- Developed an adaptive interface.
- Implemented advanced filtering options.
- Added result export.

---

## Universal Installer

#### Scripts
- Updated existing scripts with version availability display.
- Added compatibility verification.

#### Installers
- Developed a unified graphical installer with a progress bar.
- Implemented full management options (install, update, remove).
- Added database import/export.
- Created a Debian/Ubuntu package repository.
