# Administración de OpenGnsys

Bienvenido a la sección de administración de OpenGnsys. Esta área proporciona información detallada sobre todos los componentes administrativos de la plataforma.

## Componentes principales

OpenGnsys está compuesto por varios módulos administrativos que trabajan en conjunto para proporcionar una solución completa de gestión y clonación de equipos:

- **[Consola Web](oggui.md)**: Interfaz principal para la gestión de equipos y tareas.
- **[DHCP](ogdhcp.md)**: Configuración y gestión del servicio DHCP para el arranque de los clientes.
- **[Sistema de Arranque](ogboot.md)**: Mecanismos y configuraciones para el arranque de los clientes.
- **[ogLive](oglive.md)**: Sistema operativo mínimo para realizar operaciones de clonación.
- **[Motor de Clonación](ogcloneengine.md)**: Núcleo de las operaciones de clonación de equipos.
- **[Gestión de Repositorios](ogrepository.md)**: Administración de imágenes y repositorios.
- **[ogAgent](ogagent.md)**: Agente para la comunicación entre clientes y servidor.
- **[Logs y Monitorización](oglog.md)**: Herramientas para el seguimiento y análisis de operaciones.

## Introducción a la administración

La administración de OpenGnsys permite gestionar de forma centralizada un conjunto de ordenadores, creando y desplegando imágenes de disco, realizando operaciones de mantenimiento y supervisando el estado de los equipos.

Esta sección ofrece guías detalladas sobre cada componente administrativo, con instrucciones paso a paso, ejemplos de configuración y soluciones a problemas comunes.
