# Desarrolladores de OpenGnsys

Bienvenido a la sección para desarrolladores de OpenGnsys. Esta área proporciona documentación técnica detallada sobre la arquitectura interna, APIs y guías de desarrollo para cada componente del sistema.

## Componentes del sistema

OpenGnsys es un sistema modular con varios componentes interconectados. Esta sección proporciona información técnica detallada sobre cada uno de ellos:

- **[Consola Web](ogcore.md)**: Arquitectura y desarrollo del núcleo de la aplicación web.
- **[DHCP](ogdhcp.md)**: Implementación y personalización del servicio DHCP.
- **[Sistema de Arranque](ogboot.md)**: Desarrollo y extensión de los mecanismos de arranque.
- **[ogLive](oglive.md)**: Personalización y construcción del sistema operativo mínimo.
- **[Motor de Clonación](ogcloneengine.md)**: Arquitectura interna y APIs del motor de clonación.
- **[Gestión de Repositorios](ogrepository.md)**: Desarrollo de módulos para la gestión de imágenes.
- **[ogAgent](ogagent.md)**: Protocolo de comunicación y desarrollo del agente cliente.
- **[Logs y Monitorización](oglog.md)**: Integración de sistemas de registro y monitorización.

## Contribuir al proyecto

OpenGnsys es un proyecto de código abierto que agradece las contribuciones de la comunidad. Antes de comenzar a desarrollar, te recomendamos:

1. **Familiarizarte con la arquitectura**: Revisa la documentación de cada componente para entender cómo interactúan entre sí.
2. **Configurar un entorno de desarrollo**: Sigue las guías de instalación para desarrolladores.
3. **Revisar las directrices de contribución**: Asegúrate de seguir las convenciones de código y procesos de revisión.

## Herramientas de desarrollo

Para contribuir al desarrollo de OpenGnsys, necesitarás familiarizarte con las siguientes tecnologías:

- **Backend**: PHP, Python, Bash
- **Frontend**: Angular
- **Base de datos**: MySQL/MariaDB
- **Sistemas**: Linux, servicios de red

## Recursos adicionales

- Repositorio de código: [Gitea OpenGnsys](https://dev.opengnsys.es/gitea)
- Foro de desarrolladores: [Comunidad OpenGnsys](https://foro.opengnsys.es)

Esta sección proporciona la información técnica necesaria para entender, extender y personalizar los componentes de OpenGnsys según tus necesidades específicas.
