# OpenGnsys - Changelog v3.0.0 (19 Mayo 2025)

## Resumen de la versión

Esta versión principal introduce importantes mejoras en todos los componentes de OpenGnsys, incluyendo un nuevo sistema de arranque, motor de clonación actualizado, integración con Git, interfaz de administración renovada, y un nuevo instalador universal.

---

## Core Components

### OpenGnsys DHCP - ogDHCP v0.7.0

- Instalación y configuración de DHCP mediante API.
- Gestión y asignación de redes a los objetos de la consola

### OpenGnsys Boot - ogBoot v0.7.1

#### Sistema de Arranque
- Optimizados los servicios asociados a PXE
- Implementado nuevo ogLive más ligero y rápido con drivers actualizados
- Añadida herramienta de generación de ogLive con soporte para dependencias de Engine, Browser y Agent

### ogLive v3.3.0

#### Interfaz y Browser
- Incorporado nuevo OpenGnsys Browser con modo kiosko
- Añadido soporte completo para HTML5/CSS/JavaScript (ogBrowser)

#### Motor de Clonación - ogCloningEngine v0.10.0
- Reestructurado el OpenGnsys Cloning Engine y migrado parcialmente a Python
- Garantizada la utilización exclusiva de componentes open source

#### OpenGnsys Agent - ogAgent v5.3.0
- Implementado ogAgent para Windows, Linux, Mac y ogLive desarrollado en Python

#### Funcionalidades Generales
- Implementada gestión de calendarios para uso remoto de equipos

---

## OpenGnsys Repositoriy - ogRepository v0.8.1

#### Mejoras del Repositorio
- Ampliadas las funcionalidades del OpenGnsys Repository
- Integrado con otros módulos del sistema mediante API REST.

#### Transferencias
- Optimizados los métodos de transferencia: Unicast, Multicast y P2P
- Actualizados los protocolos de transferencia de imágenes

#### API y Seguridad
- Ampliadas las funcionalidades mediante API REST
- Cifrado mediante TLS para todas las API

#### Gestión Git
- Implementadas funcionalidades para imágenes sincronizadas con Git
- Integrado Forgejo para gestión avanzada de repositorios mediante interfaz web
- Añadidas funciones para crear y seleccionar repositorios Git

#### Integración con Git - ogGit v0.51
- Mejoradas las funciones en Git.lib para clonación y restauración
- Implementada biblioteca de funciones en Python
- Añadida creación automática de repositorios Git durante la instalación
- Incorporada sincronización entre repositorios Git y particiones
---

## Web de Administración - ogGui v0.13.0

#### Interfaz
- Rediseñada completamente la interfaz web con diseño responsive
- Mantenidas todas las funcionalidades previas
- Mejorada la experiencia visual y usabilidad

#### Modularidad
- Implementada gestión modular del sistema
- Incorporado sistema avanzado de roles y permisos
- Añadida búsqueda por etiquetas

#### Gestión Centralizada - ogCore v0.13.0
- Unificada la administración de todos los componentes desde la web
- Eliminada la necesidad de línea de comandos para tareas habituales

#### Acciones
- Implementado nuevo sistema de gestión de acciones por tipo de agente
- Añadida agrupación en acciones compuestas
- Incorporado historial completo de acciones
- Implementadas acciones "requeridas" pendientes
- Añadido asistente para acciones predefinidas y modo avanzado

#### Clientes
- Desarrollada nueva estructura jerárquica para grupos
- Simplificada la gestión de pertenencia a grupos
- Añadido soporte para grupos heterogéneos
- Implementada herencia de configuración para despliegue
- Incorporada visualización en cuadrícula
- Añadido concepto de "vista" dinámica basada en criterios

#### Repositorios e Imágenes
- Reorganizados en estructura de grupos
- Implementada distinción entre tipos de imágenes
- Mejorada la visualización de información para clientes
- Añadido soporte para múltiples repositorios simultáneos
- Incorporados permisos granulares y papelera de recuperación
- Implementadas búsquedas avanzadas y migración entre repositorios

#### Perfiles
- Añadidas búsquedas por criterios avanzados
- Implementada nomenclatura referencial de perfiles
- Incorporada relación entre perfiles para comparación

#### Monitorización
- Desarrollado sistema de notificaciones
- Añadidas estadísticas configurables
- Implementada ayuda contextual
- Unificada la comunicación vía OpenGnsys Core

---

## OpenGnsys Log Service

#### Sistema de Logging
- Implementada API REST para integración completa
- Centralizado el almacenamiento y gestión de logs
- Incorporados agentes de recolección 
- Añadido procesamiento en base de datos (OpenSearch)

#### Visualización
- Desarrollada interfaz adaptable
- Implementadas opciones de filtrado avanzadas
- Añadida exportación de resultados

---

## Instalador Universal

#### Scripts
- Actualizados scripts existentes con visualización de versiones disponibles
- Añadida verificación de compatibilidad

#### Instaladores
- Desarrollado instalador gráfico unificado con barra de progreso
- Implementadas opciones completas de gestión (instalación, actualización, eliminación)
- Añadida importación/exportación de base de datos
- Creado repositorio de paquetes Debian/Ubuntu
